#ifndef _JULIA_H_
#define _JULIA_H_

#include "../Maths/maths.h"
#include <iostream.h>

class Mandelbrot
{
public:
	long double		r,l,t,b;
	long double		zoom;
	int				m_Itters;

	unsigned int buffer[512][512];

	Mandelbrot() 
	{ 
		m_Itters = 32; 
		l = -2;
		r = 2;
		t = -2;
		b = 2;
		zoom = 4.0f;
	}

	void Zoom		(float _x, float _y, float _amount);
	void Calculate	(int _sizex, int _sizey);
	void Render		();
	void MulItters	(float s);
};

class Julia
{
public:
	long double		m_r,
					m_l,
					m_t,
					m_b, 
					m_zr, 
					m_zi;
	long double		m_zoom;
	int				m_Xsize,
					m_Ysize,
					m_Itters;

	unsigned int buffer[512][512];

		 Julia				();
	void InitZoom			();
	void Zoom				(float _x, float _y, float _amount);
	void Blank				();
	void Calculate			(int _skipx, int _skipy);
	void SetComplexPoint	(float _x, float _y);
	void Render				();
	void MulItters			(float s);
};

#endif