#include "colDefault.h"

//////////////////////
//	Constructors	//
//////////////////////

col4f::col4f( void )
{
	r = 0.0f;
	g = 0.0f;
	b = 0.0f;
	a = 1.0f;
}

col4f::col4f( float _nr, float _ng, float _nb, float _na)
{
	if (_nr > 1.0f) _nr = 1.0;
	if (_nr < 0.0f) _nr = 0.0;
	r = _nr;

	if (_ng > 1.0f) _ng = 1.0;
	if (_ng < 0.0f) _ng = 0.0;
	g = _ng;

	if (_nb > 1.0f) _nb = 1.0;
	if (_nb < 0.0f) _nb = 0.0;
	b = _nb;

	if (_na > 1.0f) _na = 1.0;
	if (_na < 0.0f) _na = 0.0;
	a = _na;
}

col4f::col4f( col3f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
	a = 1.0f;
}

col4f::col4f( col4f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
	a = _param->a;
}

col4f::col4f( int _nr, int _ng, int _nb, int _na)
{
	if (_nr > 255)	_nr = 255;
	if (_nr < 0)	_nr = 0;
	r = (float)_nr / 255;

	if (_ng > 255)	_ng = 255;
	if (_ng < 0)	_ng = 0;
	g = (float)_ng / 255;

	if (_nb > 255)	_nb = 255;
	if (_nb < 0)	_nb = 0;
	b = (float)_nb / 255;

	if (_na > 255)	_na = 255;
	if (_na < 0)	_na = 0;
	a = (float)_na / 255;
}

col4f::col4f( int _colour)
{
	col3f temp( _colour );

	r = temp.r;
	g = temp.g;
	b = temp.b;
	a = 1.0f;
}




//////////////////
//	Operators	//
//////////////////

col4f col4f::operator = ( col4f & _param )
{
	r = _param.r;
	g = _param.g;
	b = _param.b;
	a = _param.a;

	return (*this);
}

col4f col4f::operator = ( col3f & _param )
{
	r = _param.r;
	g = _param.g;
	b = _param.b;

	return (*this);
}

//////////////////
//	Methods		//
//////////////////

void col4f::Set( float _nr, float _ng, float _nb, float _na)
{
	if (_nr > 1.0f) _nr = 1.0;
	if (_nr < 0.0f) _nr = 0.0;
	r = _nr;

	if (_ng > 1.0f) _ng = 1.0;
	if (_ng < 0.0f) _ng = 0.0;
	g = _ng;

	if (_nb > 1.0f) _nb = 1.0;
	if (_nb < 0.0f) _nb = 0.0;
	b = _nb;

	if (_na > 1.0f) _na = 1.0;
	if (_na < 0.0f) _na = 0.0;
	a = _na;
}

void col4f::Set( int _nr, int _ng, int _nb, int _na)
{
	if (_nr > 255)	_nr = 255;
	if (_nr < 0)	_nr = 0;
	r = (float)_nr / 255;

	if (_ng > 255)	_ng = 255;
	if (_ng < 0)	_ng = 0;
	g = (float)_ng / 255;

	if (_nb > 255)	_nb = 255;
	if (_nb < 0)	_nb = 0;
	b = (float)_nb / 255;

	if (_na > 255)	_na = 255;
	if (_na < 0)	_na = 0;
	a = (float)_na / 255;
}

void col4f::Set( col3f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
	a = 1.0f;
}

void col4f::Set( col4f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
	a = _param->a;
}

col4f col4f::Lerp( col4f &v2, float s )
{
	col4f temp;
	
	temp.r= r + ( v2.r - r ) * s;
	temp.g= g + ( v2.g - g ) * s;
	temp.b= b + ( v2.b - b ) * s;
	temp.a= a + ( v2.a - a ) * s;
	return( temp );
}

