#ifndef _MATHS_H_
#define _MATHS_H_

//////////////////////////////
//	#defines - constants	//
//////////////////////////////
#define EQUALENOUGH 0.0001

#define PI					(3.14159f)
#define PIOVER180			(PI/180.0f)
#define PIUNDER180			(180.0f/PI)
#define ONEOVERRANDMAX		(0.000030518509475997192297128208258309f)

//////////////////
//	#includes	//
//////////////////
#include <math.h>
#include <stdlib.h>
#include <time.h>

class vec2f;
class vec3f;
class vec4f;
class mat3f;
class mat4f;
class quatf;
class planef;
//class frustumf;
//class AABB;

#include "vec2f.h"
#include "vec3f.h"
#include "vec4f.h"
#include "mat3f.h"
#include "mat4f.h"
#include "quatf.h"
#include "planef.h"
//#include "../octrees/octrees.h"
//#include "frustumf.h"
#include "colDefault.h"

//////////////////////////
//	#defines - macros	//
//////////////////////////
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define MAX(a,b) ((a) > (b) ? (a) : (b))

#define SQR(x) ((x)*(x))
#define SQRT(x) ((float)sqrt(x))

#define SIN(x) ((float)sin(x))
#define COS(x) ((float)cos(x))

//////////////////
//	functions	//
//////////////////
quatf M4ToQ( mat4f * param );
mat4f QToM4( quatf * param );
quatf M3ToQ( mat3f * param );
mat3f QToM3( quatf * param );

//////////////
//	inlines	//
//////////////

// random
// The following line must be at the start of the main function
// srand(time(NULL));
inline float random( void )
{
	return ((float)rand())*ONEOVERRANDMAX;
}


#endif