#ifndef _VEC2F_H_
#define _VEC2F_H_

class vec2f
{
public:

	float x, y;

	vec2f operator=(vec2f * _param);

	vec2f( void );
	vec2f( float _nx, float _ny );
	vec2f( vec2f * _param );

	void Set( float mx, float my );
	void Set( vec2f * _param );
	float Length();
	float LengthNoRoot();
	void Scale (float s);
	void Normalize();
	vec2f Negative( void );

};

inline vec2f operator+(vec2f const &a,vec2f const &b)	{return vec2f(a.x+b.x,a.y+b.y);}
inline vec2f operator+=(vec2f &a,vec2f const &b)		{a.x+=b.x;a.y+=b.y;return a;}
inline vec2f operator-(vec2f const &a,vec2f const &b)	{return vec2f(a.x-b.x,a.y-b.y);}
inline vec2f operator-=(vec2f &a,vec2f const &b)		{a.x-=b.x;a.y-=b.y;return a;}
inline vec2f operator*(vec2f const &a,float const &b)	{return vec2f(a.x*b,a.y*b);}
inline vec2f operator*(float const &a,vec2f const &b)	{return vec2f(a*b.x,a*b.y);}
inline vec2f operator*(vec2f const &a,vec2f const &b)	{return vec2f(a.x*b.x,a.y*b.y);}
inline vec2f operator*=(vec2f &a,vec2f const &b)		{a.x*=b.x;a.y*=b.y;return a;}
inline vec2f operator*=(vec2f &a,float const &b)		{a.x*=b;a.y*=b;return a;}
inline vec2f operator/(vec2f const &a,float const &b)	{return vec2f(a.x/b,a.y/b);}
inline vec2f operator/(float const &a,vec2f const &b)	{return vec2f(a/b.x,a/b.y);}
inline vec2f operator/(vec2f const &a,vec2f const &b)	{return vec2f(a.x/b.x,a.y/b.y);}
inline vec2f operator/=(vec2f &a,vec2f const &b)		{a.x/=b.x;a.y/=b.y;return a;}
inline vec2f operator/=(vec2f &a,float const &b)		{a.x/=b;a.y/=b;return a;}
inline bool  operator==(vec2f &a,vec2f const &b)		{if((fabs(a.x-b.x)<=EQUALENOUGH)&&(fabs(a.y-b.y)<=EQUALENOUGH)) return 1;else return 0;}

#endif