#ifndef _VEC4F_H_
#define _VEC4F_H_

class vec4f
{
public:
	float x,y,z,a;

	vec4f operator=(vec4f * _param);
	vec4f operator=(vec3f & _param);
	vec4f operator*(mat4f &_param);

	vec4f( void );
	vec4f( float _nx, float _ny, float _nz, float _na );
	vec4f( vec3f * _param );
	vec4f( vec4f * _param );

	void Set(float nx, float ny, float nz, float na);
	float Length();
	float LengthNoRoot();
	void Scale ( float s );
	void Normalize();
	float DotProduct ( vec4f &v2 );
	vec4f CrossProduct( vec4f &v2, vec4f &v3 );
	vec4f Lerp ( vec4f &v2, float s );
	float SeperationXZ ( int nx, int nz );
	vec4f Negative( void );
};

inline vec4f operator+(vec4f const &c,vec4f const &b)	{return vec4f(c.x+b.x,c.y+b.y,c.z+b.z,c.a+b.a);}
inline vec4f operator+=(vec4f &c,vec4f const &b)		{c.x+=b.x;c.y+=b.y;c.z+=b.z;c.a+=b.a;return c;}
inline vec4f operator-(vec4f const &c,vec4f const &b)	{return vec4f(c.x-b.x,c.y-b.y,c.z-b.z,c.a-b.a);}
inline vec4f operator-=(vec4f &c,vec4f const &b)		{c.x-=b.x;c.y-=b.y;c.z-=b.z;c.a-=b.a;return c;}
inline vec4f operator*(vec4f const &c,float const &b)	{return vec4f(c.x*b,c.y*b,c.z*b,c.a*b);}
inline vec4f operator*(float const &c,vec4f const &b)	{return vec4f(c*b.x,c*b.y,c*b.z,c*b.a);}
inline vec4f operator*(vec4f const &c,vec4f const &b)	{return vec4f(c.x*b.x,c.y*b.y,c.z*b.z,c.a*b.a);}
inline vec4f operator*=(vec4f &c,vec4f const &b)		{c.x*=b.x;c.y*=b.y;c.z*=b.z;c.a*=b.a;return c;}
inline vec4f operator*=(vec4f &c,float const &b)		{c.x*=b;c.y*=b;c.z*=b;c.a*=b;return c;}
inline vec4f operator/(vec4f const &c,float const &b)	{return vec4f(c.x/b,c.y/b,c.z/b,c.a/b);}
inline vec4f operator/(float const &c,vec4f const &b)	{return vec4f(c/b.x,c/b.y,c/b.z,c/b.a);}
inline vec4f operator/(vec4f const &c,vec4f const &b)	{return vec4f(c.x/b.x,c.y/b.y,c.z/b.z,c.a/b.a);}
inline vec4f operator/=(vec4f &c,vec4f const &b)		{c.x/=b.x;c.y/=b.y;c.z/=b.z;c.a/=b.a;return c;}
inline vec4f operator/=(vec4f &c,float const &b)		{c.x/=b;c.y/=b;c.z/=b;c.a/=b;return c;}
inline bool  operator==(vec4f &c,vec4f const &b)		{if((fabs(c.x-b.x)<=EQUALENOUGH)&&(fabs(c.y-b.y)<=EQUALENOUGH)&&(fabs(c.z-b.z)<=EQUALENOUGH)&&(fabs(c.a-b.a)<=EQUALENOUGH)) return 1;else return 0;}

#endif