
#include "myfuncs.h"




void drawLight(GLfloat LightPosition[][4]){
	glBegin(GL_LINES);			
		glVertex3f(0, 0, 0);
		glVertex3f(LightPosition[0][0], 0, 0);

		glVertex3f(LightPosition[0][0], 0, 0);
		glVertex3f(LightPosition[0][0], 0, LightPosition[0][2]);

		glVertex3f(LightPosition[0][0], 0, LightPosition[0][2]);
		glVertex3f(LightPosition[0][0], LightPosition[0][1], LightPosition[0][2]);
	glEnd();
		
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition[0]);			// Position The Light
	
	glPushMatrix();
		glTranslatef(LightPosition[0][0], LightPosition[0][1], LightPosition[0][2]);
		glutWireSphere(0.2,8,4);
	glPopMatrix();


}

void drawOverlay(Viewport &gVP, col3f buttoncol, col3f subcolour, int mode, int submode){
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, 1);

		glColor3f(buttoncol.r, buttoncol.g, buttoncol.b);
		glBegin(GL_QUADS);
		GLfloat	u = mode*0.125f, 
				w = u+0.125f;
			glTexCoord2f(u,0.0f);	glVertex2f(gVP.size.x-64-8,0+8);
			glTexCoord2f(w,0.0f);	glVertex2f(gVP.size.x-8, 0+8);
			glTexCoord2f(w,-0.5f);	glVertex2f(gVP.size.x-8, 64+8);			
			glTexCoord2f(u,-0.5f);	glVertex2f(gVP.size.x-64-8, 64+8);	
		glEnd();

		glColor3f(subcolour.r, subcolour.g, subcolour.b);
		glBegin(GL_QUADS);
			u = submode*0.0625f;
			w = u+0.0625f;
			glTexCoord2f(u,-0.5f);	glVertex2f(gVP.size.x-40,72);
			glTexCoord2f(w,-0.5f);	glVertex2f(gVP.size.x-8, 72);
			glTexCoord2f(w,-0.75f);	glVertex2f(gVP.size.x-8, 72+32);			
			glTexCoord2f(u,-0.75f);	glVertex2f(gVP.size.x-40, 72+32);	
		glEnd();


		glDisable(GL_TEXTURE_2D);



}
void drawBorder(Viewport &gVP){

		glColor3f(0.5f,0.5f,0.5f);
		glLineWidth(5);
		glBegin(GL_LINES);
			glVertex2f(0,0);
			glVertex2f(0,gVP.size.y);

			glVertex2f(0,gVP.size.y);
			glVertex2f(gVP.size.x,gVP.size.y);

			glVertex2f(gVP.size.x-1,gVP.size.y);
			glVertex2f(gVP.size.x-1,0);
			
			glVertex2f(gVP.size.x,1);
			glVertex2f(0,1);
		glEnd();

	glLineWidth(1);
}

void drawWidget(widget thiswidget){
			glLineWidth(10);
			glBegin(GL_LINES);	
			glColor3f(thiswidget.colour.r, thiswidget.colour.g, thiswidget.colour.b);
				glVertex2f(8,12);
				glVertex2f(22,12);
			glEnd();

			glLineWidth(2);
			glBegin(GL_LINES);	
			glColor3f(1.0f,0.0f,0.0f);
				glVertex2f(10,20);
				glVertex2f(10,20+thiswidget.colour.r*100.0f);
			glColor3f(0.0f,1.0f,0.0f);
				glVertex2f(15,20);
				glVertex2f(15,20+thiswidget.colour.g*100.0f);
			glColor3f(0.0f,0.0f,1.0f);
				glVertex2f(20,20);
				glVertex2f(20,20+thiswidget.colour.b*100.0f);
			glEnd();
			glLineWidth(1);
}

void cubefield(float cubesize, float spacing, int fieldsize){
int tx,ty,tz;

	for (tx = -fieldsize; tx< fieldsize; tx++){
		for (ty = -fieldsize; ty< fieldsize; ty++){
			for (tz = -fieldsize; tz< fieldsize; tz++){
			glPushMatrix();
				glTranslatef(tx*spacing, ty*spacing, tz*spacing);
				glutSolidCube(cubesize);
			glPopMatrix();
			}
		}
	}
}

void referencegrid(int size){
int mx;

	glBegin(GL_LINES);			// reference grid 
		for(mx=-size;mx<size;mx++){
			glVertex3f(-size,0,mx);	
			glVertex3f(size,0,mx);
			glVertex3f(mx,0,size);	
			glVertex3f(mx,0,-size);
		}
	glEnd();
}

void referencegridPoly(int size){
int mx, mz;

	glBegin(GL_QUADS);			// reference grid 
		for(mz=-size;mz<size;mz++){
			for(mx=-size;mx<size;mx++){
				glNormal3f( 0.0f, 1.0f, 0.0f);
				glVertex3f(mx,		0,	mz);	
				glVertex3f(mx+1.0f,	0,	mz);
				glVertex3f(mx+1.0f,	0,	mz+1.0f);	
				glVertex3f(mx,		0,	mz+1.0f);
			}
		}
	glEnd();
}

void gelplate(float xsize, float zsize, col4f gel, col4f outline, int borderwidth){

	glColor4f(gel.r, gel.g, gel.b, gel.a);
	glBegin(GL_QUADS);
			glVertex3f(xsize, 0, zsize);	
			glVertex3f(xsize, 0, -zsize);
			glVertex3f(-xsize, 0, -zsize);	
			glVertex3f(-xsize, 0, zsize);
	glEnd();

	glDisable(GL_BLEND);	

	glColor4f(outline.r, outline.g, outline.b, outline.a);	
	glLineWidth(borderwidth);
	glBegin(GL_LINES);
			glVertex3f(xsize, 0, zsize);	
			glVertex3f(xsize, 0, -zsize);

			glVertex3f(xsize, 0, -zsize);
			glVertex3f(-xsize, 0, -zsize);	

			glVertex3f(-xsize, 0, -zsize);	
			glVertex3f(-xsize, 0, zsize);

			glVertex3f(-xsize, 0, zsize);
			glVertex3f(xsize, 0, zsize);
	glEnd();
	glLineWidth(1);
	glEnable(GL_BLEND);	


}

